//+------------------------------------------------------------------+
//|                                               NewMartin_V1.0.mq4 |
//|                                           urdala  |
//|                                                   urdala@mail.ru |
//+------------------------------------------------------------------+
//      .    Shema.
//     .

//   2  

#property copyright " urdala "
#property link      "urdala@mail.ru"
#property version   "1.00"
#property strict
extern double Lot    = 0.01; //  
extern double TP     = 0.5;   //  %  
extern double SL     = 0.9;   //  %  
extern double KefLot = 1.8; //     
extern int    MaxNom = 10;   //   
extern int    Shema  = 721;   // 
extern int  MagicBuy = 34256; //   BUY (0 -  BUY )
extern int MagicSell = 45723; //   SELL (0 -  SELL )


int i=0;
int LastProf = 0,LPB,LPS;
int Slippage = 1;
bool chk;
double Lots;
string com;
datetime LastTime,LastUpd;
string StrShema="";
int LastNom = 0,LNB,LNS;
//////////////////////////////////////////////////////////////////////
int OnInit()
  {
   LastTime = 0;
   LastUpd  = 0;
   for(i=1;i<=MaxNom;i++)
     {
      StrShema=StrShema+"-"+(string)CheckNom(i,Shema);
     }
   Print("  : ",StrShema);
   return(INIT_SUCCEEDED);
  }
//////////////////////////////////////////////////////////////////////
void OnDeinit(const int reason)
  {

  }
//////////////////////////////////////////////////////////////////////
void OnTick()
  {
//////////////////////////////////////////////////////////////////////
//    
   int OB = 0,OS = 0;
   for(i=0;i<OrdersTotal();i++)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))continue;
      if(OrderMagicNumber() == MagicBuy  && OrderSymbol() == Symbol())OB++;
      if(OrderMagicNumber() == MagicSell && OrderSymbol() == Symbol())OS++;
     }
   if(OB+OS==2){LastTime=Time[0];return;}
//////////////////////////////////////////////////////////////////////
//  
   if(LastTime == Time[0])return;
   LastTime=Time[0];
//////////////////////////////////////////////////////////////////////
//    
   LastProf = 0;LastNom = 0;
   LPB = 0;LPS = 0;
   LNB = 0;LNS = 0;
   for(i=OrdersHistoryTotal()-1;i>=0;i--)
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))continue;
      if(LPB ==0 && OrderMagicNumber() == MagicBuy && OrderSymbol() == Symbol())
        {
         if(OrderProfit()>0)LPB=1;
           else LPB=-1;
         LNB = (int)OrderComment();
        }
      if(LPS ==0 && OrderMagicNumber() == MagicSell && OrderSymbol() == Symbol())
        {
         if(OrderProfit()>0)LPS=1;
           else LPS=-1;
         LNS = (int)OrderComment();
        } 
       if(LPB != 0 && LPS != 0)break;    
      }
//////////////////////////////////////////////////////////////////////
//     BUY
   if(MagicBuy > 0 && OB == 0)
     {
      if(LPB<0 && LNB<MaxNom)
        {
         Lots= NormalizeDouble(Lot*MathPow(KefLot,LNB),2);
         com =(string)(LNB+1);
        }
      else
        {
         Lots= Lot;
         com = "1";
        }
      if(CheckNom((int)com,Shema)==0)OpenOrder(Symbol(),OP_BUY,Lots,Ask,Ask-SL/100*Ask,Ask+TP/100*Ask,com,MagicBuy);
      else OpenOrder(Symbol(),OP_SELL,Lots,Bid,Bid+SL/100*Bid,Bid-TP/100*Bid,com,MagicBuy);
     }
//////////////////////////////////////////////////////////////////////
//     SELL
   if(MagicSell > 0 && OS == 0)
     {
      if(LPS<0 && LNS<MaxNom)
        {
         Lots= NormalizeDouble(Lot*MathPow(KefLot,LNS),2);
         com =(string)(LNS+1);
        }
      else
        {
         Lots= Lot;
         com = "1";
        }
      if(CheckNom((int)com,Shema)==1)OpenOrder(Symbol(),OP_BUY,Lots,Ask,Ask-SL/100*Ask,Ask+TP/100*Ask,com,MagicSell);
      else OpenOrder(Symbol(),OP_SELL,Lots,Bid,Bid+SL/100*Bid,Bid-TP/100*Bid,com,MagicSell);
     }    
//////////////////////////////////////////////////////////////////////
  }
/////////////////////////////////////////////////////////////////////
/////////                                    /////////////////
/////////////////////////////////////////////////////////////////////
int CheckNom(int nom,int shema)
  {
   int a = nom;
   int b = shema >> (a-1);
   int c = b & 1;
   return(c);
  }
//////////////////////////////////////////////////////////////////////
int OpenOrder(string symb,int cmd,double lot,double price,double stoploss,double takeprofit,string comf,int magic)
  {
   if(AccountFreeMarginCheck(Symbol(),cmd,lot)<=0)return(0);
   int err=0,f=0,ticket=0;
   color clr=CLR_NONE;
   while(f<10)
     {
      RefreshRates();
      if(cmd==0){price=MarketInfo(symb,MODE_ASK);clr=RoyalBlue;}
      if(cmd==1){price=MarketInfo(symb,MODE_BID);clr=Red;}
      ticket=OrderSend(symb,cmd,lot,NormalizeDouble(price,Digits),Slippage,0,0,comf,magic,0,clr);
      err=GetLastError();
      if(err==0) break;
      Print(WindowExpertName(),symb,"    .",err);
      f++;
      Sleep(1000);
     }
   if(ticket>0 && (takeprofit!=0 || stoploss!=0))
     {
      if(OrderSelect(ticket,SELECT_BY_TICKET))ModifyOrder(OrderTicket(),OrderOpenPrice(),stoploss,takeprofit);
     }
   return(ticket);
  }
/////////////////////////////////////////////////////////////////////////
int CloseOrder(int ticket,double lots)
  {
   int err=0,f=0;
   double price=0;
   if(!OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))return(0);
   if(lots==0)lots=OrderLots();
   if(lots<MarketInfo(OrderSymbol(),MODE_MINLOT))lots=MarketInfo(OrderSymbol(),MODE_MINLOT);
   while(f<10)
     {
      RefreshRates();
      if(OrderType()==0)price=Bid;
      if(OrderType()==1)price=Ask;
      if(OrderType()>1){chk=OrderDelete(ticket);return(0);}
      chk = OrderClose(ticket,lots,NormalizeDouble(price,Digits),Slippage,Goldenrod);
      err = GetLastError();
      if(err==0) break;
      Print(WindowExpertName(),OrderSymbol(),"    .",err);
      f++;
      Sleep(1000);
     }
   return(0);
  }
/////////////////////////////////////////////////////////////////////////
int ModifyOrder(int ticket,double price,double stoploss,double takeprofit)
  {
   int err,f=0;
   while(f<10)
     {
      RefreshRates();
      chk = OrderModify(ticket,NormalizeDouble(price,Digits),NormalizeDouble(stoploss,Digits),NormalizeDouble(takeprofit,Digits),0,CLR_NONE);
      err = GetLastError();
      if(err==0) break;
      Print(WindowExpertName(),OrderSymbol(),"    ",err);
      Sleep(1000);
      f++;
     }
   return(0);
  }
//////////////////////////////////////////////////////////////////////////
